<?php
$a = @$_REQUEST['a'];

if ($a == 'getTurbotext') {
	$api = new Turbotext();
	$orders = $api->getOrders();
	if ($orders === false) {
		echo $api->getError();
		exit;
	}

	foreach ($orders as $item) {
		$row = Db::instance()->getRow("SELECT `id`, `status` FROM `orders` WHERE `turbotext_id`={$item['id']}");

		if (!empty($row) && $row['status'] == 0) continue;

		$order = $api->getOrder($item['id']);
		if ($order === false) {
			echo $api->getError();
			exit;
		}

		$title = Db::instance()->escape($order['title']);
		$content = Db::instance()->escape($order['content']);
		$image = Db::instance()->escape($order['image']);
		if (empty($row)) {
			Db::instance()->execute("INSERT INTO `orders` SET `turbotext_id`={$item['id']}, `title`='{$title}', `image`='{$image}', `content`='{$content}'");
		} else {
			if ($row['status'] == Orders::STATUS_DECLINED) {
				Db::instance()->execute("UPDATE `orders` SET `title`='{$title}', `image`='{$image}', `content`='{$content}', `unique_textru`='', `unique_contentwatch`='', `status`=".Orders::STATUS_LOADED." WHERE `turbotext_id`={$item['id']}");
			}
		}
	}

	$obj = new Orders($db);
	$orders = $obj->getLoaded();
	echo $obj->formatList($orders);
	exit;
}

if ($a == 'loadListLoaded') {
	$obj = new Orders($db);
	$orders = $obj->getLoaded();
	echo $obj->formatList($orders, Orders::STATUS_LOADED);
	exit;
}

if ($a == 'loadListOperator') {
	$obj = new Orders($db);
	$orders = $obj->getOperator();
	echo $obj->formatList($orders, Orders::STATUS_OPERATOR);
	exit;
}

if ($a == 'loadListVerified') {
	$obj = new Orders($db);
	$orders = $obj->getVerified();
	echo $obj->formatList($orders, Orders::STATUS_ACCEPTED);
	exit;
}

if ($a == 'loadListFinished') {
	$obj = new Orders($db);
	$orders = $obj->getFinished();
	echo $obj->formatList($orders, Orders::STATUS_FINISHED);
	exit;
}

if ($a == 'loadListArchive') {
	$obj = new Orders($db);
	$orders = $obj->getFinished(true);
	echo $obj->formatList($orders, Orders::STATUS_FINISHED);
	exit;
}

if ($a == 'contentwatch') {
	$id = intval($_GET['id']);
	$row = Db::instance()->getRow("SELECT `content`, `unique_contentwatch` FROM `orders` WHERE id={$id}");

	if (!empty($row['unique_contentwatch'])) {
		echo $row['unique_contentwatch'];
		exit;
	}

	Db::instance()->execute("UPDATE `orders` SET `unique_contentwatch_in_progress`=1 WHERE id=$id");

	$content = $row['content'];

	$api = new Contentwatch();
	$unique = $api->sendText($content);
	//Log::add('contentwatch result: '.print_r($unique, true));
	if ($unique == false) {
		Db::instance()->execute("UPDATE `orders` SET `unique_contentwatch_in_progress`=0 WHERE id=$id");
		echo '<span class="text-danger">'.$api->getError().'</span>';
	} else {
		Db::instance()->execute("UPDATE `orders` SET `unique_contentwatch`='{$unique['unique']}', `unique_contentwatch_in_progress`=0 WHERE id=$id");
		echo $unique['unique'];
	}

	exit;
}

if ($a == 'textru') {
	$id = intval($_GET['id']);
	$row = Db::instance()->getRow("SELECT `content`, `unique_textru` FROM `orders` WHERE id={$id}");

	if (!empty($row['unique_textru'])) {
		echo $row['unique_textru'];
		exit;
	}

	Db::instance()->execute("UPDATE `orders` SET `unique_textru_in_progress`=1 WHERE id=$id");

	$content = $row['content'];

	$api = new Textru();
	$uid = $api->sendText($content);
	//Log::add('textru uid: '.print_r($uid, true));
	if ($uid == false) {
		Db::instance()->execute("UPDATE `orders` SET `unique_textru_in_progress`=0 WHERE id=$id");
		echo '<span class="text-danger">'.$api->getError().'</span>';
	} else {
		Db::instance()->execute("UPDATE `orders` SET `unique_textru_uid`='{$uid}' WHERE id=$id");
		echo 'ok';
	}

	exit;
}

if ($a == 'retextru') {
	$id = intval($_GET['id']);
	$row = Db::instance()->getRow("SELECT `content`, `unique_textru`, `unique_textru_in_progress` FROM `orders` WHERE id={$id}");

	if (empty($row['unique_textru_in_progress'])) {
		echo $row['unique_textru'];
		exit;
	}

	$content = $row['content'];

	$api = new Textru();
	$uid = $api->sendText($content);
	if ($uid == false) {
		Db::instance()->execute("UPDATE `orders` SET `unique_textru_in_progress`=0 WHERE id=$id");
		echo '<span class="text-danger">'.$api->getError().'</span>';
	} else {
		Db::instance()->execute("UPDATE `orders` SET `unique_textru_uid`='{$uid}' WHERE id=$id");
		echo 'ok';
	}

	exit;
}

if ($a == 'adminOperator') {
	$oIds = [];
	$operators = Db::instance()->getResult("SELECT `id` FROM `users` WHERE `type`='O'");
	foreach ($operators as $operator) {
		$oIds[] = $operator['id'];
	}

	$orders = Db::instance()->getResult("SELECT * FROM `orders` WHERE `status`=".Orders::STATUS_LOADED);
	foreach ($orders as $order) {
		if (!empty($order['unique_textru_in_progress']) || !empty($order['unique_contentwatch_in_progress']) || !empty($order['unique_etxt_in_progress'])) continue;

		$unique1 = $order['unique_textru'];
		$unique2 = $order['unique_contentwatch'];
		if ($unique1 == '' || $unique2 == '') continue;

		$unique1 = floatval(str_replace(',', '.', $unique1));
		$unique2 = floatval(str_replace(',', '.', $unique2));
		if ($unique1 == 100.0 && $unique2 == 100.0) {
			$oId = randId($oIds);
			Db::instance()->execute("UPDATE `orders` SET `operator_id`={$oId}, `status`=".Orders::STATUS_OPERATOR." WHERE `id`={$order['id']}");
		}
	}

	exit;
}

if ($a == 'adminDecline') {
	$orders = Db::instance()->getResult("SELECT * FROM `orders` WHERE `status`=".Orders::STATUS_LOADED);
	foreach ($orders as $order) {
		if (!empty($order['unique_textru_in_progress']) || !empty($order['unique_contentwatch_in_progress']) || !empty($order['unique_etxt_in_progress'])) continue;

		$unique1 = $order['unique_textru'];
		$unique2 = $order['unique_contentwatch'];
		if ($unique1 == '' || $unique2 == '') continue;

		$unique1 = floatval(str_replace(',', '.', $unique1));
		$unique2 = floatval(str_replace(',', '.', $unique2));
		if ($unique1 != 100.0 || $unique2 != 100.0) {
			Db::instance()->execute("UPDATE `orders` SET `status`=".Orders::STATUS_DECLINED." WHERE `id`={$order['id']}");

			$text = Turbotext::REJECT_TEXT;
			if ($unique1 != 100.0) {
				$text = str_replace('%SERVICE%', 'text.ru', $text);
				$text = str_replace('%UNIQUE%', $unique1, $text);
			}
			elseif ($unique2 != 100.0) {
				$text = str_replace('%SERVICE%', 'content-watch', $text);
				$text = str_replace('%UNIQUE%', $unique2, $text);
			}
			$api = new Turbotext();
			$api->rejectOrder(intval($order['turbotext_id']), $text);
		}
	}

	exit;
}

if ($a == 'advegoDecline') {
	$id = intval($_POST['id']);
	$unique = $_POST['unique'];
	$order = Db::instance()->getRow("SELECT * FROM `orders` WHERE `status`=".Orders::STATUS_OPERATOR." AND `id`={$id}");
	if (!empty($order)) {
		$unique = Db::instance()->escape($unique);
		Db::instance()->execute("UPDATE `orders` SET `status`=".Orders::STATUS_DECLINED.", `unique_advego`='{$unique}' WHERE `id`={$id}");

		$text = Turbotext::REJECT_TEXT;
		$text = str_replace('%SERVICE%', 'адвего', $text);
		$text = str_replace('%UNIQUE%', $unique, $text);
		$api = new Turbotext();
		$api->rejectOrder(intval($order['turbotext_id']), $text);
	}
	echo '';
	exit;
}

if ($a == 'advegoAccept') {
	$id = intval($_POST['id']);
	$unique = $_POST['unique'];
	$order = Db::instance()->getRow("SELECT * FROM `orders` WHERE `status`=".Orders::STATUS_OPERATOR." AND `id`={$id}");
	if (!empty($order)) {
		$unique = Db::instance()->escape($unique);
		Db::instance()->execute("UPDATE `orders` SET `status`=".Orders::STATUS_ACCEPTED.", `unique_advego`='{$unique}' WHERE `id`={$id}");
	}
	echo '';
	exit;
}

if ($a == 'finishDecline') {
	$id = intval($_POST['id']);
	$comment = $_POST['comment'];
	$order = Db::instance()->getRow("SELECT * FROM `orders` WHERE `status`=".Orders::STATUS_ACCEPTED." AND `id`={$id}");
	if (!empty($order)) {
		Db::instance()->execute("UPDATE `orders` SET `status`=".Orders::STATUS_DECLINED." WHERE `id`={$id}");

		$api = new Turbotext();
		$api->rejectOrder(intval($order['turbotext_id']), $comment);
	}
	echo '';
	exit;
}

if ($a == 'finishAccept') {
	$id = intval($_POST['id']);
	$order = Db::instance()->getRow("SELECT * FROM `orders` WHERE `status`=".Orders::STATUS_ACCEPTED." AND `id`={$id}");
	if (!empty($order)) {
		Db::instance()->execute("UPDATE `orders` SET `status`=".Orders::STATUS_FINISHED." WHERE `id`={$id}");

		$api = new Turbotext();
		$api->acceptOrder(intval($order['turbotext_id']));
		unset($api);

		$api = new Mf();
		if (!empty($order['image'])) {
			$order['image'] = Turbotext::IMAGE_BASE.$order['image'];
		}
		$postId = $api->createPost(intval($order['turbotext_id']), $order['title'], $order['content'], $order['image']);
		$postId = intval($postId);
		Db::instance()->execute("UPDATE `orders` SET `mf_post_id`={$postId} WHERE `id`={$id}");
	}
	echo '';
	exit;
}

if ($a == 'loadContent') {
	$id = intval($_GET['id']);

	$order = Db::instance()->getRow("SELECT * FROM `orders` WHERE `id`={$id}");
	if (empty($order)) {
		echo '<h4 class="text-danger">Контент не найден</h4>';
		exit;
	}

	/*
	if (!empty($order['image'])) {
		$order['content'] = '<p><a href="'.Turbotext::IMAGE_BASE.$order['image'].'" target="_blank"><img src="'.Turbotext::IMAGE_BASE.$order['image'].'" style="height: 100px; width: auto;" /></a></p>'.$order['content'];
	}
	*/

	echo $order['content'];
	exit;
}

if ($a == 'report') {
	$ids = $_POST['ids'];
	$ids = explode(';', $ids);
	if (empty($ids)) exit;

	$report = '<h3>Отчет по турботексту</h3>';
	foreach ($ids as $id) {
		$id = intval($id);
		$order = Db::instance()->getRow("SELECT * FROM `orders` WHERE `id`={$id}");
		if (empty($order)) continue;

		Db::instance()->execute("UPDATE `orders` SET `reported`=1 WHERE `id`={$id}");

		$report .= '<p>'.$order['turbotext_id'].': '.$order['title'].' - <a href="'.$order['unique_advego'].'">'.$order['unique_advego'].'</a> - <a href="http://metaphysican.com/wp-admin/post.php?post='.$order['mf_post_id'].'&action=edit">http://metaphysican.com/wp-admin/post.php?post='.$order['mf_post_id'].'&action=edit</a></p>';
	}

	mail('yakov.dn@yandex.ua', 'Отчет по турботексту', $report, 'Content-type: text/html; charset=utf-8');

	exit;
}

if ($a == 'createOrder') {
	checkAuth('create');
	$out = array();
	$title = $_POST['title'];
	$cost = $_POST['cost'];
	$charsFrom = intval($_POST['charsFrom']);
	$charsTo = intval($_POST['charsTo']);
	$additional = trim($_POST['additional']);

	if (!empty($title)) {
		$out['type'] = 'title';
		$api = new Turbotext();
		$id = $api->create($title, $cost, $charsFrom, $charsTo, $additional);
		if (empty($id)) {
			$out['error'] = $api->getError();
		} else {
			$out['status'] = 1;
		}
	} else {
		$out['type'] = 'file';
		$file = $_FILES['file'];
		if (!empty($file['name'])) {
			$list = [];
			$f = fopen($file['tmp_name'], 'r');
			while (!feof($f)) {
				$item = fgetcsv($f, 0, ';');
				if (empty($item)) continue;
				if (empty($item[1])) $item[1] = $cost;
				if (empty($item[2])) $item[2] = $charsFrom;
				if (empty($item[3])) $item[3] = $charsTo;
				if (empty($item[4])) $item[4] = $additional;
				$item[0] = iconv('WINDOWS-1251', 'UTF-8', $item[0]);
				$item[1] = iconv('WINDOWS-1251', 'UTF-8', $item[1]);
				$item[2] = iconv('WINDOWS-1251', 'UTF-8', $item[2]);
				$item[3] = iconv('WINDOWS-1251', 'UTF-8', $item[3]);
				$item[4] = iconv('WINDOWS-1251', 'UTF-8', $item[4]);
				$list[] = $item;
			}
			fclose($f);
			if (!empty($list)) {
				$out['log'] = '';
				foreach ($list as $item) {
					$api = new Turbotext();
					$id = $api->create($item[0], $item[1], $item[2], $item[3], $item[4]);
					if (empty($id)) {
						$out['log'] .= '<div class="text-danger">Ошибка при создании заказа '.$item[0].': '.$api->getError().'</div>';
					} else {
						$out['log'] .= '<div class="text-success">Создан заказ: '.$item[0].'</div>';
					}
					unset($api);
				}
			} else {
				$out['log'] = '<div class="text-danger">Ошибка при обработке файла, список пуст</div>';
			}
		} else {
			$out['log'] = '<div class="text-danger">Ошибка при загрузке файла</div>';
		}
	}

	echo json_encode($out);
	exit;
}

