<?php
class Db
{
	static private $instance;
	private $conn;

	static public function instance() {
		if (empty(self::$instance)) {
			self::$instance = new Db();
		}
		return self::$instance;
	}

	public function __construct()
	{
		$this->conn = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);
		mysqli_query($this->conn, 'SET NAMES "utf8"');
	}

	private function query($q)
	{
		$res = mysqli_query($this->conn, $q) or die(mysqli_error($this->conn));
		return $res;
	}

	public function execute($q)
	{
		mysqli_query($this->conn, $q) or die(mysqli_error($this->conn));
	}

	public function getVal($q)
	{
		$res = $this->query($q);
		if (mysqli_num_rows($res) > 0) {
			$row = mysqli_fetch_array($res);
			return $row[0];
		} else {
			return false;
		}
	}

	public function getRow($q)
	{
		$res = $this->query($q);
		if (mysqli_num_rows($res) > 0) {
			$row = mysqli_fetch_assoc($res);
			return $row;
		} else {
			return array();
		}
	}

	public function getResult($q)
	{
		$res = $this->query($q);
		if (mysqli_num_rows($res) > 0) {
			$out = array();
			while ($row = mysqli_fetch_assoc($res)) {
				$out[] = $row;
			}
			return $out;
		} else {
			return array();
		}
	}

	public function escape($str)
	{
		return mysqli_real_escape_string($this->conn, $str);
	}
}
