<?php

class Orders
{
	const STATUS_LOADED = 0;
	const STATUS_DECLINED = 1;
	const STATUS_OPERATOR = 2;
	const STATUS_ACCEPTED = 3;
	const STATUS_FINISHED = 5;

	static public $statuses = [
		0 => 'Загружен для анализа',
		1 => 'Принят',
		2 => 'Отправлен на доработку'
	];

	function __construct($db)
	{
	}

	public function formatList($orders, $status = 0)
	{
		$out = '';
		if (empty($orders)) {
			$out .= '<h4 class="text-danger">Список заказов пуст</h4>';
		} else {
			$out .= '<table class="table table-stripped" id="TableAnalyze">';
			$out .= '<tr>';
			if ($status == self::STATUS_FINISHED) {
				$out .= '<th></th>';
			}
			$out .= '<th>Turbotext ID</th>';
			$out .= '<th>Заголовок</th>';
			if ($status == self::STATUS_LOADED || $status == self::STATUS_ACCEPTED) {
				$out .= '<th>content-watch</th>';
				$out .= '<th>text.ru</th>';
				//$out .= '<th>etxt.ru</th>';
			}
			if ($status == self::STATUS_ACCEPTED) {
				$out .= '<th>адвего</th>';
			}
			if ($status == self::STATUS_OPERATOR || $status == self::STATUS_ACCEPTED) {
				$out .= '<th>Оператор</th>';
			}
			if ($status == self::STATUS_FINISHED) {
				$out .= '<th>MF Post</th>';
			}
			$out .= '</tr>';
			foreach ($orders as $order) {
				$out .= '<tr class="tr-analyze" data-id="'.$order['id'].'">';
				if ($status == self::STATUS_FINISHED) {
					$out .= '<td><input type="checkbox" name="id[]" value="'.$order['id'].'" '.(empty($order['reported']) ? 'checked="checked"' : '').' /></td>';
				}
				$out .= '<td>'.$order['turbotext_id'].'</td>';
				$out .= '<td><a href="'.BASE.'/view.php?id='.$order['id'].'" onclick="showContent('.$order['id'].', '.$status.'); return false;">'.($order['title'] ? $order['title'] : '(без заголовка)').'</a></td>';
				if ($status == self::STATUS_LOADED || $status == self::STATUS_ACCEPTED) {
					$out .= '<td class="td-contentwatch">' . ($order['unique_contentwatch_in_progress'] == 1 ? '<img src="' . BASE . '/img/loader.png" class="loader" />' : $order['unique_contentwatch']) . '</td>';
					$out .= '<td class="td-textru">' . ($order['unique_textru_in_progress'] == 1 ? '<img src="' . BASE . '/img/loader.png" class="loader" />' : $order['unique_textru']) . '</td>';
					//$out .= '<td class="td-etxt">' . ($order['unique_etxt_in_progress'] == 1 ? '<img src="' . BASE . '/img/loader.png" class="loader" />' : $order['unique_etxt']) . '</td>';
				}
				if ($status == self::STATUS_ACCEPTED) {
					$out .= '<td class="td-advego"><a href="'.$order['unique_advego'].'" target="_blank">' . $order['unique_advego'] . '</a></td>';
				}
				if ($status == self::STATUS_OPERATOR || $status == self::STATUS_ACCEPTED) {
					$out .= '<td>'.$order['operator'].'</td>';
				}
				if ($status == self::STATUS_FINISHED) {
					$out .= '<td><a href="http://metaphysican.com/wp-admin/post.php?post='.$order['mf_post_id'].'&action=edit" target="_blank">'.$order['mf_post_id'].'</a></td>';
				}
				$out .= '</tr>';
			}
			$out .= '</table>';

			if ($status == self::STATUS_LOADED) {
				$inProgress = Db::instance()->getResult("SELECT * FROM `orders` WHERE `status`=" . self::STATUS_LOADED . " AND
					(`unique_textru_in_progress`=1 OR `unique_contentwatch_in_progress`=1 OR `unique_etxt_in_progress`=1)");
				if (!empty($inProgress)) {
					$out .= '<p><b class="text-danger">Дождитель окончания анализа текстов...</b></p>';
					$out .= '<p><a href="#" onclick="reanalyze(this); return false;" class="btn btn-danger">Отправить в text.ru повторно</a></p>';
				} else {
					$out .= '<p><a href="#" onclick="analyze(this); return false;" class="btn btn-info">Анализ уникальности</a></p>';
					// кнопки след. шага
					$out .= '<p><a href="#" onclick="adminOperator(this); return false;" class="btn btn-success">Уникальные оператору</a> <a href="#" onclick="adminDecline(this); return false;" class="btn btn-warning">Неуникальные на доработку</a></p>';
				}
			}
			if ($status == self::STATUS_FINISHED) {
				$out .= '<p><a href="#" onclick="report(this); return false;" class="btn btn-info">Отправить отчет по выбранным</a></p>';
			}

			$out .= '<p>';

			$out .= '</p>';
		}
		return $out;
	}

	public function getLoaded()
	{
		$orders = Db::instance()->getResult("SELECT * FROM `orders` WHERE `status`=".self::STATUS_LOADED." ORDER BY id ASC");
		return $orders;
	}

	public function getOperator()
	{
		$currUser = checkAuth();
		if (empty($currUser)) return [];

		$add = "";
		if ($currUser['type'] == 'O') {
			$add .= " AND o.`operator_id`={$currUser['id']}";
		}

		$orders = Db::instance()->getResult("SELECT o.*, u.login as `operator`
			FROM `orders` as o
			LEFT JOIN `users` as u ON u.`id` = o.`operator_id`
 			WHERE o.`status`=".self::STATUS_OPERATOR." {$add} ORDER BY id ASC");
		return $orders;
	}

	public function getVerified()
	{
		$currUser = checkAuth();
		if (empty($currUser)) return [];

		$add = "";
		if ($currUser['type'] == 'O') {
			$add .= " AND o.`operator_id`={$currUser['id']}";
		}

		$orders = Db::instance()->getResult("SELECT o.*, u.login as `operator`
			FROM `orders` as o
			LEFT JOIN `users` as u ON u.`id` = o.`operator_id`
			WHERE o.`status`=".self::STATUS_ACCEPTED." {$add} ORDER BY id ASC");
		return $orders;
	}

	public function getFinished($archive = false)
	{
		$orders = Db::instance()->getResult("SELECT * FROM `orders` WHERE `status`=".self::STATUS_FINISHED." AND `reported`=".(empty($archive) ? 0 : 1)." ORDER BY id DESC");
		return $orders;
	}
}