<?php

/**
 * Class Textru
 *
 */
class Textru
{
	const API_URL = 'http://api.text.ru/post';
	const USER_KEY = '74e3f854a2721009c474f7635bd9c5a4';

	private $error = '';

	private function call($data)
	{
		$ch = curl_init(self::API_URL);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		$res = curl_exec($ch);
		curl_close($ch);

		return $res;
	}

	public function sendText($text, $ignore)
	{
		$params = array(
			'text' => $text,
			'userkey' => self::USER_KEY,
			'exceptdomain' => $ignore,
			'copying' => 'noadd',
			'callback' => BASE.'/callback.php?a=textrucallback'
		);
		$res = $this->call($params);

		$res = json_decode($res, true);
		if (empty($res)) {
			$this->error = 'Ошибка запроса на анализ текста';
			return false;
		}

		if (empty($res['text_uid'])) {
			$this->error = $res['error_desc'];
			return false;
		}

		return $res['text_uid'];
	}

	public function getStatus($uid)
	{
		$params = array(
			'uid' => $uid,
			'userkey' => self::USER_KEY,
			'jsonvisible' => 'detail'
		);
		$res = $this->call($params);

		$res = json_decode($res, true);
		if (empty($res)) {
			$this->error = 'Ошибка запроса на получение данных, UID='.$uid;
			return false;
		}

		if (empty($res['text_unique'])) {
			$this->error = $res['error_desc'];
			if ($res['error_code'] == 181) {
				// текст еще не проверен
				$this->error .= ', <a href="#" onclick="textruGetStatus(\''.$uid.'\'); return false;">получить результат повторно</a>';
			}
			return false;
		}

		$seo = json_decode($res['seo_check'], true);
		$water = $seo['water_percent'];
		$spam = $seo['spam_percent'];

		return array(
			'unique' => $res['text_unique'],
			'water' => $water,
			'spam' => $spam
		);
	}

	public function getError()
	{
		return $this->error;
	}

}

