<?php include 'loader.php'; ?>
<?php checkAuth('create'); ?>
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8" />
	<title>Создание заказа</title>
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />

	<link href="<?php echo BASE; ?>/css/bootstrap.css" rel="stylesheet">
	<link href="<?php echo BASE; ?>/css/bootstrap-theme.css" rel="stylesheet">
	<link href="<?php echo BASE; ?>/css/main.css" rel="stylesheet">

	<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
	<script src="<?php echo BASE; ?>/js/bootstrap.js"></script>
	<script src="<?php echo BASE; ?>/js/jquery.form.js"></script>
	<script src="<?php echo BASE; ?>/js/main.js" type="text/javascript"></script>
	<script type="text/javascript">
		var BASE = '<?php echo BASE; ?>';
	</script>
</head>
<body>
<div class="container">
	<?php require 'nav.php'; ?>
	<h2>Создание заказа</h2>
	<form action="<?php echo BASE; ?>/" method="post" id="FormCreate" enctype="multipart/form-data">
		<input type="hidden" name="a" value="createOrder" />
		<div class="form-group" id="RowTitle">
			<label for="title">Название заказа</label>
			<input type="text" name="title" id="title" value="" class="form-control" />
			<div><a href="#" onclick="toggleRowTitleFile(); return false;">Загрузить CSV-файл со списком заказов</a></div>
		</div>
		<div class="form-group" id="RowFile" style="display: none;">
			<label for="file">CSV-файл</label>
			<input type="file" name="file" id="file" value="" />
			<div>Файл в формате: <b class="text-danger">Название* ; Стоимость ; Симв.от ; Симв.до ; Приписка</b></div>
			<div class="secondary">(незаполненные поля будут взяты из формы ниже, кроме <b>Названия</b>)</div>
		</div>
		<div class="row">
			<div class="col-md-3">
				<div class="form-group">
					<label for="cost">Стоимость</label>
					<input type="text" name="cost" id="cost" value="55" class="form-control" />
				</div>
			</div>
		</div>
		<div class="form-group">
			<label for="charsFrom">Символов</label>
			<div class="row">
				<div class="col-md-2"><input type="text" name="charsFrom" id="charsFrom" value="1600" class="form-control" /></div>
				<div class="col-md-1 text-center">&mdash;</div>
				<div class="col-md-2"><input type="text" name="charsTo" id="charsTo" value="2100" class="form-control" /></div>
			</div>
		</div>
		<div class="form-group">
			<label for="additional">Приписка (необязательно)</label>
			<textarea name="additional" id="additional" class="form-control" rows="3"></textarea>
		</div>
		<p><button type="submit" class="btn btn-info">Создать заказ</button></p>
	</form>
	<div id="CreateLog"></div>
	<script type="text/javascript">
		function toggleRowTitleFile()
		{
			$('#RowTitle').hide();
			$('#RowFile').show();
		}

		$(document).ready(function() {
			var options = {
				beforeSubmit: function(formData, jqForm, options) {
					var title = formData[1].value;
					var file = formData[2].value;
					var cost = formData[3].value;
					var charsFrom = formData[4].value;
					var charsTo = formData[5].value;
					if ( (title != '' || file != '') && cost != '' && charsFrom != '' && charsTo != '') {
						$('#FormCreate BUTTON').text('Создание заказа...').attr('disabled', 'disabled');
						return true;
					} else {
						alert('Введите название заказа (или выберите файл), стоимость, кол-во символов!');
						return false;
					}
				},
				success: function(data, statusText, xhr, $form) {
					if (data.type == 'title') {
						if (data.status == 1) {
							alert('Заказ создан!');
							window.location.reload();
						} else {
							alert('Ошибка: ' + data.error);
							$('#FormCreate BUTTON').text('Создать заказ').attr('disabled', false);
						}
					}
					if (data.type == 'file') {
						$('#CreateLog').html(data.log);
						$('#FormCreate BUTTON').text('Создать заказ').attr('disabled', false);
					}
				},
				dataType: 'json'
			};
			$('#FormCreate').ajaxForm(options);

			/*
			$('#FormCreate BUTTON').on('click', function() {
				var title = $('#FormCreate INPUT[name="title"]').val();
				var cost = $('#FormCreate INPUT[name="cost"]').val();
				var charsFrom = $('#FormCreate INPUT[name="charsFrom"]').val();
				var charsTo = $('#FormCreate INPUT[name="charsTo"]').val();
				var additional = $('#FormCreate TEXTAREA[name="additional"]').val();
				if (title != '' && cost != '' && charsFrom != '' && charsTo != '') {
					$('#FormCreate BUTTON').text('Создание заказа...').attr('disabled', 'disabled');
					$.post(BASE + '/?a=createOrder',
						{
							'title': title,
							'cost': cost,
							'charsFrom': charsFrom,
							'charsTo': charsTo,
							'additional': additional
						},
						function(data)
						{
							if (data == 'OK') {
								alert('Заказ создан!');
								window.location.reload();
							} else {
								alert('Ошибка: ' + data);
								$('#FormCreate BUTTON').text('Создать заказ').attr('disabled', false);
							}
						},
						'text');
				} else {
					alert('Введите название заказа, стоимость, кол-во символов!');
				}
			});
			*/
		});
	</script>
	<?php require 'popup.php'; ?>
</div>
</body>
</html>
